unit Unit2;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.DBGrids, Data.DB,
  Data.Win.ADODB,
  dbtables, Vcl.StdCtrls, ekbasereport, ekrtf;

type
  TForm2 = class(TForm)
    ADOConnection1: TADOConnection;
    Templates: TADOTable;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    LoadBtn: TButton;
    SaveBtn: TButton;
    ConnectBtn: TButton;
    EkRTF1: TEkRTF;
    ReportBtn: TButton;
    RTFDialog: TOpenDialog;
    CloseBtn: TButton;
    procedure LoadBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure ReportBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

(*

BEGIN TRANSACTION
SET QUOTED_IDENTIFIER ON
SET ARITHABORT ON
SET NUMERIC_ROUNDABORT OFF
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
COMMIT
BEGIN TRANSACTION
GO
CREATE TABLE dbo.Templates
	(
	ID uniqueidentifier NOT NULL,
	DATA varbinary(MAX) NULL
	)  ON [PRIMARY]
	 TEXTIMAGE_ON [PRIMARY]
GO
ALTER TABLE dbo.Templates ADD CONSTRAINT
	PK_Table_1 PRIMARY KEY CLUSTERED
	(
	ID
	) WITH( STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]

GO
COMMIT


INSERT Templates
(ID, DATA)
VALUES
(NEWID(), Null)

*)

procedure TForm2.ConnectBtnClick(Sender: TObject);
begin
   ADOConnection1.Connected := True;
   Templates.Active := True;
   LoadBtn.Enabled := True;
   SaveBtn.Enabled := True;
   ReportBtn.Enabled := True;
end;

procedure TForm2.LoadBtnClick(Sender: TObject);
var BF:TBlobField;
    SFileName:string;
begin

   SFileName := 'sample_file.rtf';

   (* check file exists*)
   if not FileExists(SFileName) then
   begin
     if RTFDialog.Execute then begin
        SFileName := RTFDialog.FileName;
     end else exit;
   end;

    BF := TBlobField(Templates.FieldByName('Data'));
    Templates.Edit;
    BF.LoadFromFile(SFileName);
    Templates.Post;
    showmessage('File is saved to database');
 end;

procedure TForm2.ReportBtnClick(Sender: TObject);
var BF:TBlobField;
    BS:TStream;
    TemplateBuffer : ByteArray;
    Ln:longint;
begin

    BF := TBlobField(Templates.FieldByName('Data'));
    BS := Templates.CreateBlobStream(BF,bmRead);
    Ln := BF.BlobSize;
    SetLength(TemplateBuffer, Ln);
    BS.Read(TemplateBuffer[0],Ln);
    EkRtf1.SetTemplateBuffer(TemplateBuffer,Ln);
    EkRtf1.ExecuteOpen([],SW_SHOW);
    BS.Free;
end;

procedure TForm2.SaveBtnClick(Sender: TObject);
var BF:TBlobField;
begin
    BF := TBlobField(Templates.FieldByName('Data'));
    BF.SaveToFile('save.rtf');
    showmessage('File is saved from database to disk');
end;

procedure TForm2.CloseBtnClick(Sender: TObject);
begin
   Templates.Active := False;
   ADOConnection1.Close;
   Form2.Close;
end;

end.
